//  File NXC_Explr_Roadway.h
//  Created by: hdrake, TabbyCat Robots      2010Sep12

#ifndef _NXC_EXPLR_ROADWAY_H
#define _NXC_EXPLR_ROADWAY_H

//  *******************************
//  #defines
//  *******************************

#define BW_SENSOR      IN_3
#define COLOR_SENSOR   IN_1
#define SONAR_SENSOR   IN_4

/*
#define SENSOR_TYPE_TOUCH IN_TYPE_SWITCH
#define SENSOR_TOUCH _SENSOR_CFG(SENSOR_TYPE_TOUCH, SENSOR_MODE_BOOL)
*/


//  Following are defines for where on the roadway, the robot is located.
#define ROADWAY_TYPE_HIGHWAY            10
#define ROADWAY_TYPE_RACETRACK          20

/*
#define ROADWAY_SUBTYPE_STREET_1_LANE   11
#define ROADWAY_SUBTYPE_STREET_2_LANE   12
#define ROADWAY_SUBTYPE_STREET_3_LANE   13
#define ROADWAY_SUBTYPE_4_WAY_STOP      14
*/

/*
#define ROADWAY_SUBTYPE_STRAIGHT_1_LANES   31
#define ROADWAY_SUBTYPE_STRAIGHT_2_LANES   32
#define ROADWAY_SUBTYPE_STRAIGHT_3_LANES   33
*/

#define CAR_COLOR_BLUE                    102
#define CAR_COLOR_GREEN                   103
#define CAR_COLOR_YELLOW                  104
#define CAR_COLOR_RED                     105

//  The parameters for various speeds were here, but moved to
//  the specific robot header files, e.g WFCR_Defines_Kemmel.h


//  Following define the circular queue for passing actions from the
//  line_color_detect task to the line_follower_pro task.
#define ROADWAY_TODO_QUEUE_LENGTH   32

/*
//  Following are for displaying color detections
#define NO_DET_CLR_CHG_STR  "No Det Clr Chg"
#define NO_ACT_SET_STR  "No Action Set"
*/


//  *******************************
//  tasks
//  *******************************

task main();
task line_wiper();
task line_contrast_discover();
task realign_to_black_line();
task line_color_detect();
task line_follower_pro();

//  *******************************
//  Functions
//  *******************************
void display_light_min_max();
void display_roadway_color_array();
void display_cdtrace_buffer();
void display_lftrace_buffer();
void display_roadway_colors();
void display_sign_colors();
void display_roadway_todo_queue();
void explr_speak_color();
void initialize_speed_settings_arrays();
void line_follower_max_speed();
void roadway_pro_init();


#endif  //  End of  -  #ifndef _NXC_EXPLR_ROADWAY_H

//  End File NXC_Explr_Roadway.h

