//  File NXC_Explr_Roadway_Global_Variables.h
//  Created by: hdrake, TabbyCat Robots      2010Sep14
//  to move task line_wiper() to separate file.

//  *******************************
//  include files
//  *******************************

#ifndef _NXC_EXPLR_ROADWAY_GLOBAL_VARIABLES_H
#define _NXC_EXPLR_ROADWAY_GLOBAL_VARIABLES_H

//  *******************************
//  global variables
//  *******************************

unsigned char detected_roadway_colors[64];
unsigned char roadway_idx;
unsigned char speed_subscript;

unsigned char roadway_type;
unsigned char roadway_subtype;

unsigned char pit_location;

unsigned char car_id;

unsigned char cdtrace_buffer[64];
unsigned char cdtrace_idx;
unsigned char lftrace_buffer[64];
unsigned char lftrace_idx;

unsigned char roadway_todo_queue[ROADWAY_TODO_QUEUE_LENGTH];
unsigned char current_todo_queue_length;
unsigned char next_open_slot_idx;
unsigned char next_todo_idx;

unsigned char previous_roadway_action;
unsigned char current_roadway_action;
unsigned char next_roadway_action;

unsigned char use_passing_lanes;

short bc_power_array[NUM_OF_SPEED_SETTINGS];
short bc_gain_array[NUM_OF_SPEED_SETTINGS];
short proximity_power_factor_array[NUM_OF_SPEED_SETTINGS];
short proximity_gain_factor_array[NUM_OF_SPEED_SETTINGS];
short color_detect_delay_array[NUM_OF_SPEED_SETTINGS];
short yellow_detect_delay_array[NUM_OF_SPEED_SETTINGS];

short bc_power;
short bc_gain;
short bc_acceleration;
short proximity_power_factor;
short proximity_gain_factor;
short color_detect_delay;
short yellow_detect_delay;

short b_power;
short c_power;

short roadway_action;

int current_reflected_light_intensity;
int current_normalized;
int current_raw;
int reflected_light_min;
int reflected_light_max;
int reflected_light_mid;  //  This is simple average of min and max.
int reflected_light_range;  //  This is the difference between min and max.

int current_detected_roadway_color;
int detected_roadway_color_normalized;
int detected_roadway_color_raw;
int detected_roadway_color_other;
int previous_detected_roadway_color;


short wander;  //  This is the variance between current reflected light and the
               //  mid value.
short deviation;  //  This is wander times bc_gain.
short correction;  //  This is deviation divided by range.  So correction is a
                   //  scaled value of wander.  Correction is added to or
                   //  subtracted from each motor's power.

bool line_wiper_task_complete;
bool line_contrast_discover_task_complete;
bool realign_to_black_line_task_complete;
bool line_color_detect_task_complete;
bool line_follower_pro_task_complete;

bool do_line_follow;
bool wobble_mode;
bool take_no_action;

bool pit_this_lap;
bool pit_entrance_ahead;

short lap_number;

string roadway_action_string;

//  For line_wiper() function.
    bool discover_sync;
    char wiper_loop_cntr;
    char cw_power;
    char ccw_power;
    long discover_wipe_angle;
    long discover_return_angle;
    long discover_start_angle;
    long discover_cw_angle;
    long discover_ccw_angle;
    long wipe_begin_angle;
    long wipe_continue_angle;
    char discover_cw_pct;
    char discover_ccw_pct;

#endif  //  End of  -  #ifndef _NXC_EXPLR_ROADWAY_GLOBAL_VARIABLES_H

//  End  -  File NXC_Explr_Roadway_Global_Variables.h

