//  File WFCR_Defines_Kemmel.h
//  Created by: hdrake, TabbyCat Robots      2010Sep25

#ifndef _WFCR_DEFINES_KEMMEL_H
#define _WFCR_DEFINES_KEMMEL_H

#ifndef _WFCR_SPECIFICS
#define _WFCR_SPECIFICS
#endif  //  End of  -  #ifndef __WFCR_SPECIFICS

//  WHYY has the motors mounted upside down compared with other vehicles, and
//  thus the motors must rotate in the opposite direction for a desired direction
//  of travel.  To accomodate this define a power direction of 1 or -1 that is
//  applied to common code.
#define POWER_DIRECTION    1

//  Following are the various power and gain values for line following
//  under various conditions.
#define NUM_OF_SPEED_SETTINGS                6

#define STD_SPEED_SUBSCRIPT                  2
#define BC_STD_SPEED_POWER                  40
#define BC_STD_SPEED_GAIN                   38  //  Looks like we may need low gain for
                                                //  straights and high gain for corners.
#define STD_SPEED_PROXIMITY_POWER_FACTOR    40
#define STD_SPEED_PROXIMITY_GAIN_FACTOR     25

#define STRAIGHT_LINE_SPEED_SUBSCRIPT        3
#define BC_STRT_LINE_POWER                  50
#define BC_STRT_LINE_GAIN                   40
#define STRT_LINE_PROXIMITY_POWER_FACTOR    50
#define STRT_LINE_PROXIMITY_GAIN_FACTOR     30

#define VERY_FAST_SPEED_SUBSCRIPT            4
#define BC_VERY_FAST_POWER                  58
#define BC_VERY_FAST_GAIN                   32
#define VERY_FAST_PROXIMITY_POWER_FACTOR    60
#define VERY_FAST_PROXIMITY_GAIN_FACTOR     55

#define MAX_SPEED_SUBSCRIPT                  5
#define BC_MAX_SPEED_POWER                  66
#define BC_MAX_SPEED_GAIN                   34
#define MAX_SPEED_PROXIMITY_POWER_FACTOR    70
#define MAX_SPEED_PROXIMITY_GAIN_FACTOR     40

#define PIT_LANE_SPEED_SUBSCRIPT             0
#define BC_PIT_LANE_POWER                   35
#define BC_PIT_LANE_GAIN                    45
#define PIT_LANE_PROXIMITY_POWER_FACTOR     25
#define PIT_LANE_PROXIMITY_GAIN_FACTOR      40

#define SLOW_CURVE_SPEED_SUBSCRIPT           1
#define BC_SLOW_CURVE_POWER                 35
#define BC_SLOW_CURVE_GAIN                  45
#define SLOW_CURVE_PROXIMITY_POWER_FACTOR   30
#define SLOW_CURVE_PROXIMITY_GAIN_FACTOR    50


//  Following is the delay between color readings to verify reading
//  is valid.  This will vary with forward speed of robot.
#define COLOR_DETECT_STD_SPEED_DELAY        24
#define COLOR_DETECT_STRT_LINE_DELAY        21
#define COLOR_DETECT_VERY_FAST_DELAY        17
#define COLOR_DETECT_MAX_SPEED_DELAY        16
#define COLOR_DETECT_PIT_LANE_DELAY         24
#define COLOR_DETECT_SLOW_CURVE_DELAY       24

#define YELLOW_DETECT_STD_SPEED_DELAY       19
#define YELLOW_DETECT_STRT_LINE_DELAY       14
#define YELLOW_DETECT_VERY_FAST_DELAY        9
#define YELLOW_DETECT_MAX_SPEED_DELAY        4
#define YELLOW_DETECT_PIT_LANE_DELAY        23
#define YELLOW_DETECT_SLOW_CURVE_DELAY      23


//  *******************************
//  Functions
//  *******************************
void wfcr_kemmel_init();


#endif  //  End of  -  #ifndef _WFCR_DEFINES_KEMMEL_H

//  End File WFCR_Defines_Kemmel.h

